#ifndef _9BE9F4A4_785F_11DF_805A_18A905B1FC37_ // ---- INCLUDE PROTECTION ----
#define _9BE9F4A4_785F_11DF_805A_18A905B1FC37_ // ---- INCLUDE PROTECTION ----
/** 
 ****************************************************************************
 *
 * ServiceA
 *
 * @file    ServiceABase.hpp
 *
 * @author  Charles Halliday
 *
 * @date    15 June 2010
 *
 ****************************************************************************
 */

/**
 * ServiceA
 *
 * XMain::run outputs message to stderr
 * 
 */
#include <cppuhelper/compbase3.hxx>

#include <com/sun/star/uno/Reference.h>
#include <com/sun/star/uno/XComponentContext.hpp>
#include <com/sun/star/lang/XMain.hpp>
#include <com/sun/star/lang/XServiceInfo.hpp>
#include <com/sun/star/uno/RuntimeException.hpp>

#include <com/sun/star/lang/XInitialization.hpp>

#ifndef _OSL_MUTEX_HXX_
#include <osl/mutex.hxx>
#endif

#include <assert.h>

namespace test {

  class BaseMutex 
  {
  protected:
    mutable ::osl::Mutex m_aBaseMutex;
  };


  // test.ServiceA base class
  // Implements XMain and XServiceInfo
  typedef ::cppu::WeakComponentImplHelper3<
    ::com::sun::star::lang::XMain
    , ::com::sun::star::lang::XServiceInfo
    , ::com::sun::star::lang::XInitialization
    > ServiceAImplHelper;


  class ServiceAImplBase :
    public test::BaseMutex,
    public ServiceAImplHelper
  {
  public:
    // Constructor
    ServiceAImplBase(
      ::com::sun::star::uno::Reference< ::com::sun::star::uno::XComponentContext > const & xComponentContext);
    
    // Destructor
    virtual ~ServiceAImplBase() = 0;

    // XMain methods
    virtual sal_Int32 SAL_CALL run( const ::com::sun::star::uno::Sequence< ::rtl::OUString >& aArguments ) throw (::com::sun::star::uno::RuntimeException);

    // XServiceInfo methods
    virtual ::rtl::OUString SAL_CALL getImplementationName(  ) throw (::com::sun::star::uno::RuntimeException);
    virtual sal_Bool SAL_CALL supportsService( const ::rtl::OUString& ServiceName ) throw (::com::sun::star::uno::RuntimeException);
    virtual ::com::sun::star::uno::Sequence< ::rtl::OUString > SAL_CALL getSupportedServiceNames(  ) throw (::com::sun::star::uno::RuntimeException);

  private:
   
  };

} // namespace close


#endif  // ---- INCLUDE PROTECTION ----
