#ifndef _9C13BC30_785F_11DF_805A_18A905B1FC37_ // ---- INCLUDE PROTECTION ----
#define _9C13BC30_785F_11DF_805A_18A905B1FC37_ // ---- INCLUDE PROTECTION ----
/** 
 ****************************************************************************
 *
 * ServiceA service
 *
 * @file    ServiceAImpl.hpp
 *
 * @author  Charles Halliday
 *
 * @date    15 June 2010
 *
 ****************************************************************************
 */

#include "ServiceABase.hpp"

#include <com/sun/star/lang/XMain.hpp>

namespace test {

/**
 * ServiceA service
 *
 * Sends message to ZSReflector service and receives a reply
 * 
 */
class ServiceAImpl : public ServiceAImplBase
  {

  public:

    ServiceAImpl( ::com::sun::star::uno::Reference< ::com::sun::star::uno::XComponentContext > const & xComponentContext);

    virtual ~ServiceAImpl();

    // Interface com.sun.star.lang.XInitialization

    // Method of com.sun.star.lang.XInitialization
    virtual void SAL_CALL
    initialize(
      const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any >& aArguments )
      throw (
        ::com::sun::star::uno::Exception,
        ::com::sun::star::uno::RuntimeException );

    // Interface com.sun.star.lang.XMain

    // Method of com.sun.star.lang.XMain
    virtual ::sal_Int32 SAL_CALL
    run(
      const ::com::sun::star::uno::Sequence< ::rtl::OUString >& aArguments )
      throw ( ::com::sun::star::uno::RuntimeException );

  // Additional class member implementations

  private:
    // Copy constructor
    ServiceAImpl(const ServiceAImpl & r);

    // Assignment operator
    ServiceAImpl&operator=(const ServiceAImpl & r);

    ::com::sun::star::uno::Reference
    < ::com::sun::star::uno::XComponentContext > const mXComponentContext;

  };


} // namespace close


#endif  // ---- INCLUDE PROTECTION ----
