#ifndef _9C13BC30_785F_11DF_805A_18A905B1FC37_ // ---- INCLUDE PROTECTION ----
#define _9C13BC30_785F_11DF_805A_18A905B1FC37_ // ---- INCLUDE PROTECTION ----
/** 
 ****************************************************************************
 *
 * ServiceC service
 *
 * @file    ServiceCImpl.hpp
 *
 * @author  Charles Halliday
 *
 * @date    15 June 2010
 *
 ****************************************************************************
 */

#include "ServiceCBase.hpp"

#include <com/sun/star/lang/XMain.hpp>

namespace test {

/**
 * ServiceC service
 *
 * Sends message to ZSReflector service and receives a reply
 * 
 */
class ServiceCImpl : public ServiceCImplBase
  {

  public:

    ServiceCImpl( ::com::sun::star::uno::Reference< ::com::sun::star::uno::XComponentContext > const & xComponentContext);

    virtual ~ServiceCImpl();

    // Interface com.sun.star.lang.XInitialization

    // Method of com.sun.star.lang.XInitialization
    virtual void SAL_CALL
    initialize(
      const ::com::sun::star::uno::Sequence< ::com::sun::star::uno::Any >& aArguments )
      throw (
        ::com::sun::star::uno::Exception,
        ::com::sun::star::uno::RuntimeException );

    // Interface com.sun.star.lang.XMain

    // Method of com.sun.star.lang.XMain
    virtual ::sal_Int32 SAL_CALL
    run(
      const ::com::sun::star::uno::Sequence< ::rtl::OUString >& aArguments )
      throw ( ::com::sun::star::uno::RuntimeException );

  // Additional class member implementations

  private:
    // Copy constructor
    ServiceCImpl(const ServiceCImpl & r);

    // Assignment operator
    ServiceCImpl&operator=(const ServiceCImpl & r);


    // For com.sun.star.lang.XInitialization
  };


} // namespace close


#endif  // ---- INCLUDE PROTECTION ----
